$(function() {

  /*CLICA NO BOTÃO DE AÇÃO*/
  $("#btn-action").on("tapstart", function() {
    //console.log(e);
    if ($("#btn-action").attr("mission") == "call") {
      if ($("#btn-action").attr("ready") == "false") {
        $.dialog.info(
          "Obtendo localização",
          "Estamos obtendo sua localização, por favor espere o mapa carregar para obtermos o seu endereço."
        );
        return;
      }
      if (localStorage.getItem("user") != null) {
        if (localStorage.status == "D")
          $.dialog.info("Bloqueado", "Sua conta foi bloqueada. Entre em contato com taximoto@sysvale.com");
        else
          sendCall();
      } else {
        viewLogin();
        //        $("#view-login").velocity("transition.slideRightIn", 300, {
        //          display: "block"
        //        });
        //        $(".overlay").show(0);
      }
    } else if ($(this).attr("mission") == "abort") {
      /*CONFIRMAÇÃO DE ABORTAR CORRIDA*/
      abortCall();
    }
  });
});

/**
 * [sendCall description]
 * @return {[type]} [description]
 */
function sendCall() {
  var reference = "";
  if (localStorage.reference) {
    reference = localStorage.reference;
  }

  $.dialog.prompt(
    "Chamar mototáxi para",
    $(".user-local").html(),
    "Informe um ponto de referência ou detalhes para auxiliar a sua localização:",
    "prompt-reference",
    reference,
    function() {
      localStorage.reference = $("input.prompt-reference").val();
      localStorage.address = $(".user-local").html();
      $.dialog.close();
      sendCallRequest();
    }
  );
}

/**
 * [sendCallRequest description]
 * @return {[type]} [description]
 */
function sendCallRequest() {
  $.dialog.waiting("Procurando mototaxistas");
  $.post("send-request", {
      x: aLatitude,
      y: aLongitude,
      address: localStorage.address,
      reference: localStorage.reference,
      placeId: user.getPlaceId()
    }, locationWorker,
    function() {
      $.dialog.close();
      $.dialog.info("", "Não foi possível iniciar uma corrida. Tente novamente mais tarde.");
    }
  );
}

/**
 * [abortCall description]
 * @return {[type]} [description]
 */
function abortCall() {
  $.dialog.confirm(
    "Cancelar corrida?",
    "Você está prestes a cancelar uma corrida. Sua conta será bloqueada na próxima vez.",
    function() {
      $.post("cancel-request", {}, function(data) {
        closeWorker();
      }, function(data) {
        $.dialog.info("Erro", "Erro ao cancelar corrida. Tente novamente em instantes.")
      });
    }
  );
  $(".menu .menu-title").html("Taximoto");
}

var timeOutCall;

/**
 * [locationWorker description]
 * @param  {[type]} data [description]
 * @return {[type]}      [description]
 */
function locationWorker(data) {
  $.dialog.close();
  if (data > 0) {
    $.dialog.waiting("Chamando mototaxistas...");
    timeOutCall = setTimeout(function() {
      $.dialog.close();
      $.dialog.info("Desculpe", "Não localizamos mototaxistas.");
    }, timeCall);
  } else if (data == -1)
    $.dialog.info("Em corrida", "O usuário possui uma corrida ativa.")
  else if (data == -2)
    $.dialog.info("Bloqueado", "Seu usuário está bloqueado. Entre em contato com o suporte.")
  else
    $.dialog.info("Ops!!", "Não encontramos mototaxista disponível.");
}

/**
 * [showWorker description]
 * @param  {[type]} data [description]
 * @return {[type]}      [description]
 */
function showWorker(data) {
  map.setOptions({
    draggable: false
  });
  clearTimeout(timeOutCall);
  $(".moto-name", ".info-run").html(data.name);
  $(".moto-avatar", ".info-run").attr("src", data.photo);
  $(".moto-type", ".info-run").html(data.model_vehicle);
  $(".moto-plate", ".info-run").html(data.license_plate);
  $(".moto-registration", ".info-run").html(data.registration);
  $(".info-run", ".panel-action-body").velocity("transition.bounceLeftIn", {
    duration: 300,
    display: "block",
    complete: resizeMap
  });
  $("#btn-action").attr("mission", "abort").removeClass("btn-green").addClass("cancel-color").text("Cancelar corrida");
  gps.disableUpdateAddress();
  wLatitude = data.x_coordinate;
  wLongitude = data.y_coordinate;
  $(".image-gps").hide(0);
  gps.setRoute(wLatitude, wLongitude);
  //gps.distanceMatrix(data.x_coordinate, data.y_coordinate, lLatitude, lLongitude);
}

/**
 * [closeWorker description]
 * @return {[type]} [description]
 */
function closeWorker() {
  map.setOptions({
    draggable: true
  });
  localStorage.removeItem("reference");
  localStorage.removeItem("address");
  $.dialog.close();
  $("#btn-action").attr("mission", "call").removeClass("cancel-color").addClass("btn-green").text("Chamar mototáxi");
  $(".info-run", ".panel-action-body").velocity("transition.bounceRightOut", {
    duration: 300,
    display: "none",
    complete: resizeMap
  });
  $(".image-gps").show(0);
  gps.updateAddress();
  marker_client.setMap(null);
  marker_worker.setMap(null);
}
