$(function() {
  $.support.cors = true;
  $.each(["put", "delete", "post", "get"], function(i, method) {
    $[method] = function(url, data, callback, fail) {
      return $.ajax({
        // url: "http://taximoto.sysvale.com/app-client/"+url,
        url: serverUrl + url,
        type: method,
        dataType: "json",
        crossDomain: true,
        data: data,
        success: callback,
        error: fail
      });
    };
  });

  $.fn.send = function(success, error) {
    $(this).submit(function() {
      console.log("send");
      var inputs = $(this).find("input, select");
      $(inputs).removeClass('invalid');
      $(".invalid-msg").remove();
      for (var i = 0; i < $(inputs).length; i++) {
        var regex = $(inputs).eq(i).attr('regex');
        if (regex && regex.length) {
          if (!(new RegExp(regex, "i")).exec($(inputs).eq(i).val())) {
            console.log("error[" + regex + "]: " + $(inputs).eq(i).val());
            $(inputs).eq(i).after("<div class='text-xs invalid-msg'>ex: " + $(inputs).eq(i).attr('placeholder') + "</div>");
            $.alert("Campo inválido!");
            $(inputs).eq(i).addClass('invalid').focus();
            return false;
          } else {
            console.log("ok[" + regex + "]: " + $(inputs).eq(i).val());
          }
        } else console.log("not regex: " + $(inputs).eq(i).val());
      }

      $.post($(this).attr("action"), $(this).serialize(), success, error);
      return false;
    });
  };

  $.fn.sendImage = function(success, error) {
    $(this).submit(function() {
      $.dialog.waiting("Enviando...");
      $.ajax({
        type: "POST",
        url: serverUrl + $(this).attr("action"),
        data: new FormData(this),
        enctype: 'multipart/form-data',
        processData: false, // tell jQuery not to process the data
        contentType: false // tell jQuery not to set contentType
      }).success(success).fail(error).done(function() {
        $.dialog.close();
      });
      return false;
    });
    $(this).find('input[type="file"]').change(function() {
      var str = $(this).val(),
        arr = [/.png$/, /.jpg$/, /.jpge$/];
      for (var i = 0; i < arr.length; i++)
        if (str.search(arr[i]) > 0) {
          $(this).closest('form').submit();
          return;
        }
      $.alert("Arquivo inválido!");
    });
  };
});
