var app = {

  initialize: function() {
    this.bindEvents();
  },

  bindEvents: function() {
    document.addEventListener('deviceready', this.onDeviceReady, false);
    document.addEventListener('deviceready', connectSocket, false);
  },

  onDeviceReady: function() {
    // Recebe informações do dispositivo e grava nos formulários
    $("input[name='model']").val(device.model);
    $("input[name='version_so']").val(device.version);
    $("input[name='uuid']").val(device.uuid);

    // Verifica conectividade e inicializa métodos com GPS
    connection.initialize();
  },

  onError: function(error) {
    var msg = "Desculpe-nos, aconteceu algum erro! Entre em contato com taximoto@sysvale.com para que possamos ajudar a solucionar o problema\n" + "Code: " + error.code + "\nMessage: " + error.message;
    alert(msg);
    navigator.app.exitApp();
  }

};
