function connectSocket() {
  socket = io.connect('http://taximoto.sysvale.com:3000');
  socket.on("call-client", function(data) {

    if (data.status == "up-worker") {
      // data.x_coodinate
      // data.y_coodinate
      wLatitude = data.x_coordinate;
      wLongitude = data.y_coordinate;
      var coordinates = new google.maps.LatLng(wLatitude, wLongitude);
      if (marker_worker) {
        marker_worker.setPosition(coordinates);
      } else {
        marker_worker = new google.maps.Marker({
          position: coordinates,
          map: map,
          icon: "img/marker-moto.svg"
        });
      }
    }

    if (data.status == "N") {
      $(".menu .menu-title").html("Taximoto");
      $.dialog.confirm(
        "Cancelou",
        "O mototaxista cancelou a corrida. Deseja chamar outro mototáxi?",
        function() {
          $.dialog.close();
          sendCallRequest();
        });
      closeWorker();
    } else if (data.status == "F") {
      $(".menu .menu-title").html("Taximoto");
      $.alert("Corrida finalizada. Obrigado por utilizar o taximoto.", 5000);
      showRating();
      closeWorker();
    } else if (data.status == "B") {
      $.dialog.info("Status", "Embarque realizado.")
    } else if (data.status == "E") {
      $.dialog.close();
      var msgWorker = modalMsgWorker(data.photo, data.msg);
      $.dialog.info("Chamada atendida", msgWorker);
      $.alert("Sua corrida foi aceita. Aguarde o mototaxista.", 5000);
      $(".menu .menu-title").html("Corrida em andamento");
      showWorker(data);
    }

  });
  socket.on("connect", function() {
    $.alert("Conectado");
    if (connected == false) {
      // gps.initialize();
      connected = true;
    }
    socket.emit('join-client', {
      uuid: device.uuid
    });
  });
  socket.on("disconnect", function() {
    $.alert("Desconectado");
  });
};
